"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Custom404Page = void 0;
var react_1 = __importStar(require("react"));
var site_error_1 = __importDefault(require("../sections/site-error"));
var site_base_1 = __importDefault(require("../page/site-base"));
var util_1 = require("../util");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var site_page_split_1 = __importDefault(require("../sections/site-page-split"));
var solution_1 = require("primeobjects-helper-ui/build/cjs/hooks/solution");
var Custom404Page = function (props) {
    var url = props.url, host = props.host, solutionApiEndpoint = props.solutionApiEndpoint;
    var _a = (0, react_1.useState)(""), domain = _a[0], setDomain = _a[1];
    var solution = (0, react_1.useRef)(null);
    var message = props.message
        ? props.message
        : "Sorry, we couldn't find the page you’re looking for.";
    var title = props.title ? props.title : "404 - Page Not Found";
    (0, react_1.useEffect)(function () {
        if (!solution.current) {
            try {
                var domain_1 = (0, primeobjects_helper_util_1.getRootDomainFromUrl)("".concat((0, primeobjects_helper_util_1.getWindow)().location));
                (0, util_1.callApiBase)("".concat(solutionApiEndpoint, "current-solution"), { domain: domain_1 }, "GET").then(function (result) {
                    (0, solution_1.setSolution)(result);
                    solution.current = result;
                    setDomain(domain_1);
                });
            }
            catch (err) {
                console.error(err);
            }
        }
    }, []);
    return domain.length > 0 && solution.current ? (react_1.default.createElement(site_base_1.default, { solution: solution.current, headProps: { host: host, url: url, title: title, domain: domain }, navigation: [] },
        react_1.default.createElement(site_page_split_1.default, null,
            react_1.default.createElement(site_error_1.default, { message: message })))) : (react_1.default.createElement(react_1.default.Fragment, null));
};
exports.Custom404Page = Custom404Page;
exports.default = exports.Custom404Page;
//# sourceMappingURL=404.js.map