"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListFiltersSection = void 0;
var react_1 = __importDefault(require("react"));
var lodash_1 = require("lodash");
var primeobjects_ui_web_basic_1 = require("primeobjects-ui-web-basic");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var cjs_1 = require("primeobjects-helper-ui/build/cjs");
var ListFiltersSection = function (props) {
    var _a, _b;
    var wrapperClassName = (_a = props.wrapperClassName) !== null && _a !== void 0 ? _a : "";
    var wrapperStyle = (_b = props.wrapperStyle) !== null && _b !== void 0 ? _b : {};
    var filters = (0, lodash_1.isArray)(props.filters) ? props.filters : [];
    var solution = (0, cjs_1.useSolution)();
    var onResize = function (width, height) {
        if (props.onResize)
            props.onResize(width, height);
    };
    var onRemove = function (filter) {
        if (props.onRemove)
            props.onRemove(filter);
    };
    var renderFilters = function () {
        return (0, lodash_1.map)(filters, function (filter, index) {
            var _a;
            var icon = "/icons/platform/".concat(filter.type, ".svg");
            if (filter.entityName) {
                icon = (_a = (0, primeobjects_helper_util_1.getEntity)(solution, filter.entityName)) === null || _a === void 0 ? void 0 : _a.icon;
            }
            return (react_1.default.createElement("div", { key: index, className: "float-left flex px-2 py-1 mb-2 mr-1 shadow-sm border border-gray-100 rounded-md bg-white items-center h-8" },
                react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: icon, style: { width: 15 } }),
                react_1.default.createElement(primeobjects_ui_web_basic_1.GradientDiv, { className: "text-sm mx-2 leading-none h-5 items-center", tooltip: filter.text, style: { maxWidth: filter.type == "search" ? 80 : 200 } }, filter.text),
                react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/x.svg", size: 12, className: "cursor-pointer", onClick: function () { return onRemove(filter); } })));
        });
    };
    return (react_1.default.createElement(react_1.default.Fragment, null, filters.length > 0 && (react_1.default.createElement(primeobjects_ui_web_basic_1.ResizeDetectorDiv, { className: "float-left w-full px-4 pt-4 pb-2 ".concat(wrapperClassName), style: wrapperStyle, onDetect: onResize }, renderFilters()))));
};
exports.ListFiltersSection = ListFiltersSection;
exports.default = exports.ListFiltersSection;
//# sourceMappingURL=filters.js.map