"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteTitle = void 0;
var react_1 = __importDefault(require("react"));
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var h1_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/h1"));
var h2_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/h2"));
var h3_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/h3"));
var h4_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/h4"));
var h5_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/h5"));
var SiteTitle = function (props) {
    var _a;
    var title = props.title, subTitle = props.subTitle, titleSize = props.titleSize, subTitleSize = props.subTitleSize;
    var Title = react_1.default.createElement("h2");
    var SubTitle = react_1.default.createElement("h3");
    var titleClassName = props.titleClassName ? props.titleClassName : "";
    var subTitleClassName = props.subTitleClassName
        ? props.subTitleClassName
        : "";
    var titleStyle = (_a = props.titleStyle) !== null && _a !== void 0 ? _a : {};
    var subTitleStyle = props.subTitleStyle ? props.subTitleStyle : {};
    switch (titleSize) {
        case "h1": {
            titleClassName = "my-10 text-3xl sm:text-4xl ".concat(titleClassName);
            Title = h1_1.default;
            break;
        }
        case "h3": {
            titleClassName = "my-6 text-xl sm:text-2xl ".concat(titleClassName);
            Title = h3_1.default;
            break;
        }
        case "h4": {
            titleClassName = "my-4 text-lg sm:text-xl ".concat(titleClassName);
            Title = h4_1.default;
            break;
        }
        default: {
            titleClassName = "my-8 text-2xl sm:text-3xl ".concat(titleClassName);
            Title = h2_1.default;
            break;
        }
    }
    switch (subTitleSize) {
        case "h2": {
            subTitleClassName = "my-8 text-xl sm:text-2xl ".concat(subTitleClassName);
            SubTitle = h2_1.default;
            break;
        }
        case "h4": {
            subTitleClassName = "my-4 text-base sm:text-lg ".concat(subTitleClassName);
            SubTitle = h4_1.default;
            break;
        }
        case "h5": {
            subTitleClassName = "my-4 text-sm sm:text-base ".concat(subTitleClassName);
            SubTitle = h5_1.default;
            break;
        }
        default: {
            subTitleClassName = "my-10 text-lg sm:text-xl ".concat(subTitleClassName);
            SubTitle = h3_1.default;
            break;
        }
    }
    return (0, core_1.isNonEmptyString)(title) || (0, core_1.isNonEmptyString)(subTitle) ? (react_1.default.createElement(react_1.default.Fragment, null,
        (0, core_1.isNonEmptyString)(title) && (react_1.default.createElement(Title, { className: "font-bold tracking-tight ".concat(titleClassName, " ").concat((0, core_1.isNonEmptyString)(subTitle) ? "mb-1" : ""), style: titleStyle }, title)),
        (0, core_1.isNonEmptyString)(subTitle) && (react_1.default.createElement(SubTitle, { className: "tracking-tight ".concat(subTitleClassName, " ").concat((0, core_1.isNonEmptyString)(title) ? "mt-0" : ""), style: subTitleStyle }, subTitle)))) : (react_1.default.createElement(react_1.default.Fragment, null));
};
exports.SiteTitle = SiteTitle;
exports.default = exports.SiteTitle;
//# sourceMappingURL=site-title.js.map