import React, { ReactElement } from "react";
import { TPageHeadProps } from "./head";
import { TCurrentContextSettings } from "../context/use-current-context";
export type TAppBasePageProps = {
    allowGuest?: boolean;
    query: Record<string, any>;
    host: string;
    url: string;
    domain: string;
    port: string;
    solution: Record<string, any>;
    headProps: TPageHeadProps;
    currentContextSettings?: TCurrentContextSettings;
    showMeModal?: string | number | undefined;
    showOrgModal?: string | number | undefined;
    showSolutionModal?: string | number | undefined;
    onContextReady: (context: Record<string, any>) => void;
    appTrack?: boolean;
    libTrack?: boolean;
};
export declare const AppBasePage: (props: TAppBasePageProps & React.DetailedHTMLProps<React.HTMLAttributes<HTMLDivElement>, HTMLDivElement>) => ReactElement;
export default AppBasePage;
