//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect, useState } from "react";
import { getPrimaryColor } from "primeobjects-helper-ui";
// import NavSectionInternal from "primeobjects-ui-web-application/build/cjs/sections/nav";
import NavSectionInternal from "../sections/nav";
import MeModal from "../sections/modals/me-modal";
import OrgModal from "../sections/modals/org-modal";
import SolutionModal from "../sections/modals/solution-modal";
import { isNil } from "lodash";
import { getGlobalComponent } from "../util";
import { hexToRgbaString } from "primeobjects-helper-util/build/cjs/colors";
var NavSection = undefined;
export var PageWrapper = function (props) {
    var _a, _b;
    if (!NavSection) {
        console.log("Get global components in /pages/wrapper.tsx");
        NavSection = getGlobalComponent("NavSection", NavSectionInternal);
    }
    var query = props.query, solution = props.solution, host = props.host, url = props.url, domain = props.domain, locale = props.locale, locales = props.locales, UserForm = props.UserForm, OrgForm = props.OrgForm, SolutionForm = props.SolutionForm, AppBasePage = props.AppBasePage, hideNav = props.hideNav, appTrack = props.appTrack, port = props.port, hideNavMeButton = props.hideNavMeButton, allowGuest = props.allowGuest;
    var primaryColor = getPrimaryColor(solution);
    var backgroundColor = (_b = (_a = solution === null || solution === void 0 ? void 0 : solution.app) === null || _a === void 0 ? void 0 : _a.backgroundColor) !== null && _b !== void 0 ? _b : hexToRgbaString(primaryColor["50"], 0.3);
    var _c = useState(undefined), showMe = _c[0], setShowMe = _c[1];
    var _d = useState(undefined), showOrg = _d[0], setShowOrg = _d[1];
    var _e = useState(80), navWidth = _e[0], setNavWidth = _e[1];
    var _f = useState(undefined), showSolution = _f[0], setShowSolution = _f[1];
    var onContextReady = function (newContext) {
        props.onContextReady && props.onContextReady(newContext);
    };
    useEffect(function () {
        var _a;
        if (showMe !== props.showMeModal) {
            setShowMe((_a = props.showMeModal) !== null && _a !== void 0 ? _a : undefined);
        }
    }, [props.showMeModal]);
    useEffect(function () {
        var _a;
        if (showSolution !== props.showSolutionModal) {
            setShowSolution((_a = props.showSolutionModal) !== null && _a !== void 0 ? _a : undefined);
        }
    }, [props.showSolutionModal]);
    useEffect(function () {
        var _a;
        if (showOrg !== props.showOrgModal) {
            setShowOrg((_a = props.showOrgModal) !== null && _a !== void 0 ? _a : undefined);
        }
    }, [props.showOrgModal]);
    var onClickMe = function () {
        var v = Date.now();
        setShowMe(v);
        props.onShowMe && props.onShowMe(v);
    };
    var onClickSolution = function () {
        var v = Date.now();
        setShowSolution(v);
        props.onShowSolution && props.onShowSolution(v);
    };
    var onClickOrg = function () {
        var v = Date.now();
        setShowOrg(v);
        props.onShowOrg && props.onShowOrg(v);
    };
    var onCloseMe = function () {
        setShowMe(undefined);
        props.onShowMe && props.onShowMe(undefined);
    };
    var onCloseSolution = function () {
        setShowSolution(undefined);
        props.onShowSolution && props.onShowSolution(undefined);
    };
    var onCloseOrg = function () {
        setShowOrg(undefined);
        props.onShowOrg && props.onShowOrg(undefined);
    };
    var onClickNavItem = function (item) {
        props.onClickNavItem && props.onClickNavItem(item);
    };
    var renderTopArea = function () {
        return props.topArea ? (props.topArea) : (React.createElement("div", { className: "w-full border-b relative flex flex-row border-".concat(primaryColor.name, "-300"), style: { minHeight: 65, height: 65 } }));
    };
    var onResizeNav = function (width) {
        setNavWidth(width);
    };
    var renderMainArea = function () {
        return (React.createElement("div", { className: "flex flex-row w-full", style: { backgroundColor: backgroundColor } },
            !hideNav && (React.createElement(NavSection, { hidden: hideNav, solution: solution, allowGuest: allowGuest, onClickMe: onClickMe, onClickOrg: onClickOrg, onClickSolution: onClickSolution, onClickItem: onClickNavItem, onResize: onResizeNav, hideMeButton: hideNavMeButton, supportResize: props.supportNavResize, fixedSize: props.fixedSizedNavArea })),
            React.createElement("div", { style: {
                    width: "calc(100% - ".concat(hideNav ? 0 : navWidth, "px)")
                } }, props.mainArea)));
    };
    return (React.createElement(AppBasePage, { allowGuest: allowGuest, solution: solution, appTrack: appTrack, onContextReady: onContextReady, onClickNavItem: props.onClickNavItem, currentContextSettings: props.currentContextSettings, headProps: __assign(__assign({}, props.headProps), { host: host, url: url, domain: domain, query: query, locale: locale, locales: locales, port: port }), onClickMe: onClickMe, onClickOrg: onClickOrg, onClickSolution: onClickSolution },
        React.createElement("div", { className: "w-full flex flex-col" },
            renderTopArea(),
            renderMainArea(),
            props.bottomArea),
        React.createElement(MeModal, { show: !isNil(showMe), onClickClose: onCloseMe, Form: UserForm }),
        React.createElement(OrgModal, { show: !isNil(showOrg), onClickClose: onCloseOrg, Form: OrgForm }),
        React.createElement(SolutionModal, { show: !isNil(showSolution), onClickClose: onCloseSolution, Form: SolutionForm })));
};
export default PageWrapper;
//# sourceMappingURL=wrapper.js.map